#!/bin/bash

#########################################################################
# This program is free software: you can redistribute it and/or modify  #
# it under the terms of the version 3 of the GNU General Public License #
# as published by the Free Software Foundation.                         #
#                                                                       #
# This program is distributed in the hope that it will be useful, but   #
# WITHOUT ANY WARRANTY; without even the implied warranty of            #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      #
# General Public License for more details.                              #
#                                                                       #
# You should have received a copy of the GNU General Public License     #
# along with this program. If not, see <http://www.gnu.org/licenses/>.  #
#                                                                       #
# Written by and Copyright (C) Francois Fleuret                         #
# Contact <francois@fleuret.org> for comments & bug reports             #
#########################################################################

function error () {
    echo $1 1>&2
    exit 1
}

## Header ############################################################

cat <<EOF
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title></title>
</head>

<body>

EOF

## Body ##############################################################

echo "<h1>Directory content</h1>"

echo

echo "<pre>"

for d in $(find . -maxdepth 1 -type d -name "[^.]?*" | sort); do
    echo "<a href=\"${d}\">${d}</a>"

    # most_recent=$(find ${d} -type f -exec stat --printf="%Y %n\n" '{}' \; | sort | tail -1 | awk '{print $4}')

    # if [[ ${most_recent} ]]; then
        # date=$(date -r ${most_recent})
    # else
        # date=$(date -r ${d})
    # fi

    # echo "${date} <a href=\"${d}\">${d}</a>"
done

echo "</pre>"

echo

## Footer ############################################################

cat <<EOF
</body>

</html>
EOF

######################################################################
